freeslot("MT_GEMMAPLAT", "SPR_BLDR")
mobjinfo[MT_GEMMAPLAT] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 48*FRACUNIT,
	height = 32*FRACUNIT,
	dispoffset = -1,
	flags = MF_SOLID|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_SLIDEME
}

mobjinfo[MT_ROCKCRUMBLE2].mass = 0 //This is stupid

//gemmastyle command
COM_AddCommand("gemmastyle", function(player, arg)
	if not (player.mo and player.mo.valid) then CONS_Printf(player, "This can only be used in a level!") return end
	if arg
		if arg == "0"
			CONS_Printf(player, "Style 0 for Gemma has been deprecated as of version 1.2. Defaulting to style 1.")
			player.gemmastyle = 1
			if io and player == consoleplayer
				local file = io.openlocal("client/Gemma.dat", "w+")
				file:write(1)
				file:close()
			end
		elseif arg == "1" or arg == "default"
			player.gemmastyle = 1
			if io and player == consoleplayer
				local file = io.openlocal("client/Gemma.dat", "w+")
				file:write(1)
				file:close()
			end
		elseif arg == "2"
			player.gemmastyle = 2
			if io and player == consoleplayer
				local file = io.openlocal("client/Gemma.dat", "w+")
				file:write(2)
				file:close()
			end
		else
			CONS_Printf(player, "gemmastyle - Changes how Gemma's jump ability controls.")
			CONS_Printf(player, "#1: Let go of Jump while riding the platform to hop off it.")
			CONS_Printf(player, "#2: Press Jump while riding the platform to hop off it.")
		end
	else
		CONS_Printf(player, "gemmastyle - Changes how Gemma's jump ability controls.")
		CONS_Printf(player, "#1: Let go of Jump while riding the platform to hop off it.")
		CONS_Printf(player, "#2: Press Jump while riding the platform to hop off it.")
	end
end, 0)

//Shatter the platform when it dies
addHook("MobjDeath", function(mobj)
	local i=0 while i<3
		local ghost = P_SpawnGhostMobj(mobj)
		if i == 1 then S_StartSound(ghost, sfx_cdfm32) end
		ghost.fuse = TICRATE
		ghost.flags = $&~MF_NOGRAVITY
		ghost.flags2 = mobj.flags2&MF2_OBJECTFLIP
		ghost.eflags = mobj.eflags&MFE_VERTICALFLIP
		P_SetObjectMomZ(ghost, 4*FRACUNIT, false)
		if mobj.tracer and mobj.tracer.valid and mobj.tracer.player
			P_InstaThrust(ghost, (i*-ANGLE_90)+(mobj.tracer.player.cmd.angleturn<<16)+ANGLE_90, 4*mobj.scale)
		else
			P_InstaThrust(ghost, P_RandomKey(ANGLE_MAX), 4*mobj.scale)
		end
		ghost.sprite = SPR_BLDR
		ghost.frame = i+1
		i=$+1
	end
end, MT_GEMMAPLAT)

//Teleport the platform
addHook("MobjThinker", function(mobj)
	if not mobj.tracer return end
	if not (mobj.tracer.valid and mobj.tracer.skin == "gemma"
	and mobj.tracer.player and mobj.tracer.player.gemmasmash > 1)
	or not (mobj.flags&MF_NOGRAVITY)
		if mobj.flags&MF_NOGRAVITY
			mobj.z = $-P_MobjFlip(mobj.tracer)
			mobj.flags = $&~MF_NOGRAVITY&~MF_NOCLIPHEIGHT
			mobj.momx = mobj.tracer.momx
			mobj.momy = mobj.tracer.momy
			mobj.fuse = TICRATE*3
			if mobj.tracer.valid and (P_IsObjectOnGround(mobj.tracer)
			or (mobj.tracer.player and mobj.tracer.player.pflags&PF_JUMPED
			and not (mobj.tracer.player.pflags&PF_THOKKED)
			and not (mobj.tracer.player.pflags&PF_SPINNING)))
				P_KillMobj(mobj)
				return
			elseif mobj.tracer.valid and mobj.tracer.player
			and mobj.tracer.player.pflags&PF_SPINNING
				mobj.z = $-mobj.tracer.height*P_MobjFlip(mobj.tracer)/2
				mobj.momx = $*4/5
				mobj.momy = $*4/5
			end
		elseif P_IsObjectOnGround(mobj)
			P_KillMobj(mobj)
			return
		end
	elseif mobj.tracer.eflags&MFE_VERTICALFLIP
		mobj.eflags = $|MFE_VERTICALFLIP
		mobj.flags2 = $|MF2_OBJECTFLIP
		P_TeleportMove(mobj,mobj.tracer.x, mobj.tracer.y,
		mobj.tracer.z+mobj.tracer.height)
	else
		mobj.eflags = $&~MFE_VERTICALFLIP
		mobj.flags2 = $&~MF2_OBJECTFLIP
		P_TeleportMove(mobj,mobj.tracer.x, mobj.tracer.y,
		mobj.tracer.z-mobj.height)
	end
end, MT_GEMMAPLAT)

//Die
addHook("MobjFuse", function(mobj)
	P_KillMobj(mobj)
	return true
end, MT_GEMMAPLAT)

//Stupid
addHook("MobjThinker", function(mobj)
	if mobj.gemmarock
		mobj.gemmarock = $+1
		if mobj.gemmarock > TICRATE*5
			P_SpawnGhostMobj(mobj)
			P_RemoveMobj(mobj)
		end
	end
end, MT_ROCKCRUMBLE2)

//Platform Collision
addHook("MobjCollide", function(thing, tmthing)
	if thing and thing.valid and tmthing and tmthing.valid
		if (tmthing.flags&MF_ENEMY or tmthing.flags&MF_BOSS or tmthing.flags&MF_MONITOR)
		and (thing.z - thing.scale <= tmthing.z + tmthing.height
		and thing.z + thing.height + thing.scale >= tmthing.z)
			if thing.tracer and thing.tracer.valid and thing.tracer.player
				if thing.flags&MF_NOGRAVITY
					thing.tracer.player.gemmasmash = 0
					thing.tracer.state = S_PLAY_SPRING
					thing.tracer.player.pflags = $|PF_JUMPED&~PF_STARTJUMP|PF_NOJUMPDAMAGE&~PF_THOKKED
					if thing.tracer.player.cmd.buttons&BT_JUMP
						thing.tracer.player.pflags = $|PF_STARTJUMP
					end
					thing.tracer.momz = abs($)*P_MobjFlip(thing.tracer)
					if tmthing.flags&MF_MONITOR then thing.tracer.momz = $*2 end
				end
				P_DamageMobj(tmthing, thing, thing.tracer)
			else
				P_DamageMobj(tmthing, thing, thing)
			end
			P_KillMobj(thing)
		elseif not tmthing.player or (thing.tracer and thing.tracer == tmthing)
			return false
		elseif P_IsObjectOnGround(tmthing) and not (tmthing.eflags&MFE_ONGROUND)
			if thing.tracer and thing.tracer.valid and thing.flags&MF_NOGRAVITY
				tmthing.momx = thing.tracer.momx
				tmthing.momy = thing.tracer.momy
			else
				tmthing.momx = thing.momx
				tmthing.momy = thing.momy
			end
			if tmthing.state != S_PLAY_WALK and tmthing.momx == 0 and tmthing.momy == 0
			and (tmthing.player.cmd.forwardmove or tmthing.player.cmd.sidemove)
				tmthing.state = S_PLAY_WALK
			end
			tmthing.player.powers[pw_noautobrake] = max($,2)
		end
	end
end, MT_GEMMAPLAT)

//Platform Protection
addHook("ShouldDamage", function(target, inflictor, source, damage, damagetype)
	if not (target and target.valid and target.player and target.skin == "gemma"
	and target.player.gemmasmash and target.player.gemmasmash >= 2 and not (damagetype&DMG_DEATHMASK)) then return end
	local inflvald = (inflictor and inflictor.valid)
	if (damagetype != DMG_WATER and not inflvald)
	or (inflvald and inflictor.type == MT_SPIKE
	and (target.eflags & MFE_VERTICALFLIP) == (inflictor.eflags & MFE_VERTICALFLIP))
	or (inflvald and not P_IsObjectOnGround(target)
	and inflictor.type != MT_WALLSPIKE)
	
	if inflvald
		local bottomheight = target.z
		local topheight = target.z + target.height

		if (target.eflags & MFE_VERTICALFLIP)
			local swap = bottomheight
			bottomheight = topheight
			topheight = swap
		end

		if not ((P_MobjFlip(target)*(bottomheight - (inflictor.z + inflictor.height/2)) > 0)
		and (P_MobjFlip(target)*(target.momz - inflictor.momz) < 0)) then return end
	
		target.z = $+(inflictor.height/2)
	else
		target.z = $+P_MobjFlip(target)
	end
	
	local spoark = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_THUNDERCOIN_SPARK)
	spoark.fuse = TICRATE/3
	spoark.scale = target.scale*3/2
	target.momz = max(abs(target.momz), 10*target.scale)
	target.player.gemmasmash = 0
	target.state = S_PLAY_SPRING
	target.player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE&~PF_THOKKED
	if target.player.cmd.buttons&BT_JUMP
		target.player.pflags = $|PF_STARTJUMP
	end
	S_StartSound(target, sfx_cdfm65)
	
	return false end
end, MT_PLAYER)

//Start the ability
addHook("AbilitySpecial", function(player)
	if player.mo and player.mo.valid
	and player.mo.skin == "gemma" and player.panim != PA_PAIN
		if (player.gemmasmash and player.gemmasmash > 1)
		or player.gemmaspindash
			player.pflags = $&~PF_JUMPED
			P_DoJump(player)
			player.gemmasmash = 0
			if not (player.pflags&PF_SPINNING)
				player.pflags = $|PF_THOKKED&~PF_NOJUMPDAMAGE
			end
		elseif (not (player.pflags&PF_THOKKED) or player.charflags&SF_MULTIABILITY
		or player.powers[pw_super]) and not P_IsObjectInGoop(player.mo)
			player.gemmasmash = 1
			player.pflags = $|PF_THOKKED|PF_JUMPED&~PF_STARTJUMP&~PF_NOJUMPDAMAGE&~PF_SPINNING
			local dumbgravity = P_GetMobjGravity(player.mo)
			if player.mo.eflags&MFE_UNDERWATER and not P_IsObjectInGoop(player.mo)
			dumbgravity = player.mo.scale*2/-5*P_MobjFlip(player.mo) end
			if player.mo.eflags&MFE_UNDERWATER
				player.mo.momz = $+(max(min(dumbgravity,player.mo.scale/2),player.mo.scale/-2)*-32)
			else
				player.mo.momz = $+(max(min(dumbgravity,player.mo.scale/2),player.mo.scale/-2)*-48)
			end
			S_StartSound(player.mo, sfx_s3kabf)
		end
	end
end)

//Rock spindash
addHook("SpinSpecial", function(player)
	if player.mo and player.mo.valid
	and player.mo.skin == "gemma" and player.panim != PA_PAIN
	and player.gemmasmash
		if player.gemmasmash > 1
		and not (player.pflags&PF_USEDOWN) and not player.gemmaspindash
			player.gemmadashspeed = 15*FRACUNIT
			player.mo.state = S_PLAY_SPINDASH
			player.gemmaspindash = 1
			S_StartSound(player.mo, sfx_spndsh)
		end
		return true
	end
end)

//Bouncy
addHook("MobjDamage", function(target, inflictor)
	if inflictor and inflictor.valid and inflictor.skin == "gemma"
	and inflictor.player
		if inflictor.player.gemmasmash
			if inflictor.player.gemmasmash > 1
				inflictor.player.gemmasmash = 0
				inflictor.state = S_PLAY_SPRING
				inflictor.player.pflags = $|PF_JUMPED&~PF_STARTJUMP|PF_NOJUMPDAMAGE
				if inflictor.player.cmd.buttons&BT_JUMP
					inflictor.player.pflags = $|PF_STARTJUMP
				end
			else
				inflictor.momz = $*2
			end
		end
		inflictor.player.pflags = $&~PF_THOKKED
	end
end)

//Bouncy!
addHook("MobjDeath", function(target, inflictor)
	if inflictor and inflictor.valid and inflictor.skin == "gemma"
	and inflictor.player and target and target.valid and target.flags&MF_MONITOR
		if inflictor.player.gemmasmash
			if inflictor.player.gemmasmash > 1
				inflictor.player.gemmasmash = 0
				inflictor.state = S_PLAY_SPRING
				inflictor.player.pflags = $|PF_JUMPED|PF_STARTJUMP|PF_NOJUMPDAMAGE
				if inflictor.player.cmd.buttons&BT_JUMP
					inflictor.player.pflags = $|PF_STARTJUMP
				end
			else
				inflictor.momz = $*2
			end
		end
		inflictor.player.pflags = $&~PF_THOKKED
	end
end)

//Reset Gemma's variables
local resetgemma = function(player)
	player.gemmamomz = 0
	if player.mo and player.mo.valid
	and (player.gemmasmash == 1 or player.gemmasquish)
		player.mo.spritexscale = FRACUNIT
		player.mo.spriteyscale = FRACUNIT
	end
	player.gemmasmash = 0
	player.gemmasquish = 0
end
addHook("PlayerSpawn", function(player)
	resetgemma(player)
	//I/O maybe
	if io and player.gemmastyle == nil and player == consoleplayer
		local file = io.openlocal("client/Gemma.dat")
		if file
			local num = file:read("*n")
			if num != nil and num >= 0 and num <= 2
				COM_BufInsertText(consoleplayer, "gemmastyle "..num)
			end
			file:close()
		end
	end
end)

//Main Thinker	
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "gemma"
		//Disallows the rest of the code in certain circumstances
		if P_PlayerInPain(player)
		or (player.pflags & PF_SLIDING)
		or player.powers[pw_carry] != CR_NONE
		or player.spectator
		or player.playerstate != PST_LIVE
		or not player.mo.health
		or player.panim == PA_PAIN
		or player.powers[pw_super] == 1
		or player.iseggrobo
		or player.isjettysyn
		or player.guard
		or player.actionstate
		or player.powers[pw_nocontrol]
		or player.exiting
			resetgemma(player)
			if player.charflags&SF_STOMPDAMAGE
				player.charflags = $&~SF_STOMPDAMAGE
			end
		return end
		
		//Do the ability
		if player.gemmasmash
			if player.gemmasmash == 1
				if P_IsObjectInGoop(player.mo)
					player.mo.spritexscale = FRACUNIT
					player.mo.spriteyscale = FRACUNIT
					player.gemmasmash = 0
				elseif player.mo.eflags&MFE_SPRUNG
					player.mo.spritexscale = FRACUNIT
					player.mo.spriteyscale = FRACUNIT
					player.mo.momz = $*5/4
					player.mo.momx = $*5/4
					player.mo.momy = $*5/4
					S_StartSound(player.mo, sfx_sprong)
					if (player.mo.eflags & MFE_UNDERWATER)
						local ex = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_UWEXPLODE)
						if ex and ex.valid ex.scale = $/2 end
					else
						P_SpawnMobjFromMobj(player.mo, 0, 0, player.mo.scale*P_MobjFlip(player.mo), MT_SPINDUST)
					end
					player.gemmasmash = 0
				elseif P_IsObjectOnGround(player.mo)
					player.mo.spritexscale = FRACUNIT
					player.mo.spriteyscale = FRACUNIT
					player.gemmasquish = 6
					player.mo.state = S_PLAY_GLIDE_LANDING
					if player.powers[pw_super]
						P_Earthquake(player.mo, player.mo, RING_DIST)
					end
					if player == displayplayer and not splitscreen
						P_StartQuake(32*FRACUNIT, 2+min(player.powers[pw_super],1))
					end
					
					if player.cmd.buttons&BT_JUMP
						player.mo.momz = player.gemmamomz/-2
						if player.mo.momz*P_MobjFlip(player.mo) < 8*player.mo.scale
							P_SetObjectMomZ(player.mo, 8*FRACUNIT, false)
						end
						player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE|PF_THOKKED
						if player.gemmastyle == 2
							player.gemmasmash = 2
						else
							player.gemmasmash = 5
						end
						player.pflags = $|PF_JUMPSTASIS
						player.charflags = $|SF_STOMPDAMAGE
						local rock = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_GEMMAPLAT)
						rock.sprite = SPR_BLDR
						rock.frame = 0
						rock.tracer = player.mo
						rock.target = player.mo
						rock.flags2 = $|MF2_LINKDRAW
						local ghost = P_SpawnGhostMobj(rock)
						ghost.frame = 4
						if RF_FLOORSPRITE
							ghost.renderflags = $|RF_FLOORSPRITE|RF_NOSPLATBILLBOARD|RF_SHADOWDRAW
							ghost.fuse = TICRATE*5
						else
							ghost.fuse = TICRATE
						end
						ghost.angle = player.cmd.angleturn<<16
						S_StartSound(player.mo, sfx_s3k82)
						S_StartSoundAtVolume(player.mo, sfx_s3k7a, 192)
						S_StartSoundAtVolume(player.mo, sfx_s1b9, 192)
					else
						S_StartSound(player.mo, sfx_s3k4c)
						S_StartSoundAtVolume(player.mo, sfx_s3k59, 192)
						player.gemmasmash = 0
					end
					
					local thok = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_THOK)
					thok.color = SKINCOLOR_BEIGE
					thok.destscale = thok.scale*16
					thok.scalespeed = $*2
					thok.tics = $*3/2
					thok.fuse = thok.tics
					
					local i = 0	while i < 8
						local fa = (i*(ANGLE_180/4))
						local ns = 16 << FRACBITS
						local mo = P_SpawnMobj(player.mo.x, player.mo.y,
						player.mo.z+(player.mo.height/2), MT_ROCKCRUMBLE2)
						if mo and mo.valid
							if player.powers[pw_super]
								mo.momx = FixedMul(sin(fa),ns)*2
								mo.momy = FixedMul(cos(fa),ns)*2
							else
								mo.momx = FixedMul(sin(fa),ns)/2
								mo.momy = FixedMul(cos(fa),ns)/2
							end
							mo.gemmarock = 1
							mo.target = player.mo
							mo.flags = $&~MF_NOCLIP&~MF_NOCLIPTHING|MF_MISSILE|MF_NOCLIPHEIGHT
							mo.shadowscale = FRACUNIT/3
							mo.radius = $*4
						end
						i = $+1
					end
					
					S_StopSoundByID(player.mo, sfx_s3kabf)
				else
					player.pflags = $|PF_JUMPSTASIS
					player.mo.state = S_PLAY_ROLL
					player.mo.spritexscale = FRACUNIT+FixedDiv(player.mo.momz/96,player.mo.scale)
					player.mo.spriteyscale = FRACUNIT-FixedDiv(player.mo.momz/96,player.mo.scale)
					if player.cmd.buttons&BT_JUMP
						local thok = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_THOK)
						thok.color = player.mo.color
						thok.destscale = 1
						thok.scalespeed = thok.scale/6
						thok.tics = $*3/2
						thok.fuse = thok.tics
						thok.spritexscale = player.mo.spritexscale
						//thok.spriteyscale = player.mo.spriteyscale
						local thok = P_SpawnMobjFromMobj(player.mo,
						FixedDiv(player.mo.momx/-2,player.mo.scale),
						FixedDiv(player.mo.momy/-2,player.mo.scale),
						FixedDiv(player.mo.momz/-2,player.mo.scale),MT_THOK)
						thok.color = player.mo.color
						thok.destscale = 1
						thok.scalespeed = thok.scale/6
						P_SetScale(thok, thok.scale-thok.scalespeed/2)
						thok.tics = $*3/2
						thok.fuse = thok.tics
						thok.spritexscale = player.mo.spritexscale
						thok.spriteyscale = player.mo.spriteyscale
					else
						local ghost = P_SpawnGhostMobj(player.mo)
						ghost.color = SKINCOLOR_BEIGE
						ghost.colorized = true
						ghost.fuse = 4
						ghost.spritexscale = player.mo.spritexscale
						ghost.spriteyscale = player.mo.spriteyscale
					end
					if player.mo.momz*P_MobjFlip(player.mo) > -32*player.mo.scale
						player.mo.momz = $+(P_GetMobjGravity(player.mo)*8)
					elseif player.mo.momz*P_MobjFlip(player.mo) > -48*player.mo.scale
						player.mo.momz = $+(P_GetMobjGravity(player.mo)*2)
					end
					local sectorthing = P_PlayerTouchingSectorSpecial(player, 0, 0)
					if sectorthing and sectorthing.valid then
						for fof in sectorthing.ffloors()
							if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
							and (abs(fof.topheight - player.mo.z) <= 40*player.mo.scale) then
								EV_CrumbleChain(player.sectorthing, fof)
							end
						end
					end
				end
			elseif not (player.cmd.buttons&BT_JUMP) and player.gemmasmash == 5
				player.pflags = $&~PF_JUMPED
				P_DoJump(player)
				player.gemmasmash = 0
				player.pflags = $|PF_THOKKED&~PF_STARTJUMP&~PF_NOJUMPDAMAGE
			elseif P_IsObjectOnGround(player.mo)
			or player.pflags&PF_STARTJUMP
				player.gemmasmash = 0
			else
				player.pflags = $|PF_JUMPED
				if not player.gemmaspindash
					player.mo.state = S_PLAY_GLIDE_LANDING
				end
				if player.gemmasmash >= 3 and player.gemmasmash < 5
					if player.cmd.buttons&BT_JUMP
						player.gemmasmash = $+1
					else
						player.gemmasmash = 2
					end
				end
			end
			player.gemmamomz = player.mo.momz
		elseif player.charflags&SF_STOMPDAMAGE
			player.charflags = $&~SF_STOMPDAMAGE
		end
		
		if player.gemmasquish
			player.gemmasquish = $-1
			player.mo.spritexscale = FRACUNIT+(player.gemmasquish)*FRACUNIT/12
			player.mo.spriteyscale = FRACUNIT-(player.gemmasquish)*FRACUNIT/12
		end
		
		if player.gemmaspindash
			if player.gemmaspindash == -1
				player.gemmaspindash = 0
				player.pflags = $&~PF_JUMPED
				player.gemmasmash = 0
			elseif player.cmd.buttons & BT_SPIN
			and player.gemmasmash and player.gemmasmash > 1
				player.mo.state = S_PLAY_SPINDASH
				
				local chargecalculation = (6*(player.gemmadashspeed  - (player.mindash)))/((player.maxdash) - (player.mindash))
				player.gemmadashspeed = min(max($+FRACUNIT, player.mindash), player.maxdash)
				local soundcalculation = (6*(player.gemmadashspeed  - (player.mindash)))/((player.maxdash) - (player.mindash))
				if not player.spectator and soundcalculation != chargecalculation
					S_StartSound(player.mo, sfx_spndsh)
				end
			
				local i = 0 while i <= (leveltime%7)/2 // 1, 2, 3 or 4 particles
					local particle
					if player.mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER) // overrides fire version
						particle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SMALLBUBBLE)
					else
						particle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SPINDUST)
						if (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
							particle.state = S_SPINDUST_FIRE1
						end
					end
				
					particle.target = player.mo
					particle.destscale = (2*player.mo.scale)/3
					P_SetScale(particle, particle.destscale)
					if (player.mo.eflags & MFE_VERTICALFLIP) // readjust z position if needed
						particle.z = player.mo.z + player.mo.height - particle.height
					end
					local prandom = {}
					prandom[0] = P_RandomFixed()<<2 // P_RandomByte()<<10
					prandom[1] = P_RandomRange(-30, 30) // P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT
					prandom[2] = P_RandomFixed()<<3 // P_RandomByte()<<11
					P_SetObjectMomZ(particle, player.gemmadashspeed /50 + prandom[0], false)
					P_InstaThrust(particle,
							player.mo.angle + (prandom[1]*ANG1),
							-FixedMul(player.gemmadashspeed /12 + FRACUNIT + prandom[2], player.mo.scale))
					particle.momx = $+player.mo.momx
					particle.momy = $+player.mo.momy
					particle.momz = $+player.mo.momz
					P_TryMove(particle, particle.x+particle.momx, particle.y+particle.momy, true)
				
					i = $+1
				end
			elseif not (player.cmd.buttons&BT_USE)
			or P_IsObjectOnGround(player.mo)
				P_InstaThrust(player.mo, player.mo.angle, FixedMul(player.gemmadashspeed , player.mo.scale))
				S_StartSound(player.mo, sfx_s23c)
				player.pflags = $|PF_SPINNING&~PF_THOKKED
				player.gemmaspindash = -1
				if player.mo.momz*P_MobjFlip(player.mo) < 0
					player.mo.momz = 0
				end
				player.mo.state = S_PLAY_ROLL
			else
				player.gemmaspindash = 0
			end
		end
	end
end)